//
// Load a level
//
#include <cybiko.h>
#include "header.h"

struct FileInput file_input;
struct FileFind searcher; 

// util
int waitinput(struct module_t *);

void centext(struct module_t *,char *,int );	

void simplemap(struct module_t *,char *,char *,int);

void loadlevel(char *data,char *fn,char *mapname){
	int pos=0;
	char in;

	// Load the level
	FileInput_ctor(&file_input);

	if( FileInput_open( &file_input,fn )){
		// Get the map name
		do{
			in=FileInput_read_byte (&file_input );  
			if (in>=32 && pos<25){mapname[pos++]=in;}
		}while(in>10);// enter is 10and/or13	
		mapname[pos]=0;
		TRACE("Map name: [%s]",mapname);
		
		// Load the actual map
		pos=0;
		do{
			in=FileInput_read_byte (&file_input );  
			// ignore special characters
			if (in>=32){
				// turn 0(char:0) into "0" (char:48)
				if (in<58){
					data[pos++]=in-48;
				}else{
					data[pos++]=in;
				}
			}
			
		}while(pos<(MAPWIDTH*MAPHEIGHT));	
			
		TRACE("Map size: [%d]",pos);
	}

	FileInput_dtor( &file_input, LEAVE_MEMORY );
}

//
void ucase(char *in){
	int i=0;
	do{
		if (in[i]>92 && in[i]<123){in[i]-=32;}
		i++;
	}while(in[i]!=0);
}
//

void findit(char *ext,struct menulist *item,int *i){
	struct File file_info;

	int j;
	char temp[20];

	strcpy(temp,ext);

	#if DEBUG==1 
		TRACE("Scanning '%s' for files.",ext);
	#endif

	File_ctor( &file_info );

	// Lower case

	FileFind_ctor( &searcher, &file_info, ext );

	do{
		if (FileFind_next_element( &searcher )){
			#if DEBUG==1
				TRACE("%d: >%s<",*i,file_info.name);
			#endif 

			strcpy(item[*i].name,file_info.name);
			*i=*i+1;
		}
		
	}while( FileFind_has_more_elements( &searcher ) );

	// Upper case extenstion

	ucase(temp);

	FileFind_init( &searcher, &file_info, temp );

	do{
		if (FileFind_next_element( &searcher )){
			#if DEBUG==1  
				TRACE("%d: >%s<",*i,file_info.name);
			#endif 

			strcpy(item[*i].name,file_info.name);
			*i=*i+1;
		}
	}while( FileFind_has_more_elements( &searcher ) );
	FileFind_dtor( &searcher, LEAVE_MEMORY );

	File_dtor( &file_info , LEAVE_MEMORY );
}

//
//
//

int lister(struct module_t *ptr_main_module,struct menulist *item,int items){
	int sel=0,i,ext=0;
	char temp[50],*dis,*data;

	data=(char *)malloc(MAPWIDTH*MAPHEIGHT); 
	memset(data,0,sizeof(data));

	dis=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0); 

	//Make sure our font is correct!
	Graphics_set_font(ptr_main_module->m_gfx, mini_bold_font );

	items--; // so 2 items become 0,1 not 0,1,2

	do{
		memset(data,0,sizeof(data));
		memset(temp,0,sizeof(temp));

		loadlevel(data,item[sel].name,temp);
		simplemap(ptr_main_module,data,temp,0);

		// ------------------------ 
			 
		switch( waitinput(ptr_main_module)){
			case KEY_ESC:
				ext=1;sel=-1;
			break;

			case KEY_LEFT:
			case KEY_O:
				sel--;
				if(sel<0){sel=items;}
			break; 

			case KEY_RIGHT:
			case KEY_P:
				sel++;
				if(sel>items){sel=0;}
			break;

			case KEY_ENTER:
				ext=1;
			break;
		}
		// -------------
		#if DEBUG==1
			TRACE("Selected: #%d / %d",sel,items);
		#endif

	}while(ext==0);

	#if DEBUG==1
	if ((sel)!=-1){
		TRACE("Selected: #%d %s",sel,item[sel]);
	}else{
		TRACE("Selected: Exit/Back");
	}
	#endif

	free(data);

	return (sel);	
}

