//
// CybikoTD by ssjx 08/2007 > 2023+
//
// TODO :
// Load levels from file? <<--improve select screen
// On screen displays
// restart ability <<--done!
// Multiple beams and rockets <<--check out rockets
// Weapon select and info screen <<--invert weapon colours!
// Make sure weapon charging effects all weapons

#include <cybiko.h>
#include "header.h"

struct module_t main_module;
struct DirectKeyboard* ptr_direct_keyboard;
struct Bitmap bmp_grid,bmp;
struct Graphics vgfx;

struct menulist *listitem;

// Functions used from utils.c
void infowindow(struct module_t *,char *,struct listinfo *,int);
int selectwindow(struct module_t *,struct listinfo *,int );

int getinput(struct module_t *);
void snapshot(char *);
int abs(int);

// from graphics.c
void hitext(struct module_t *,char *,int , int );
void arrow(struct module_t *,int ,int );
void smallwindow(struct module_t *,char *,struct listinfo *,int,int );

// from select.c
int selectweapon(struct module_t *,struct mywep *,int);
int selectmap(struct module_t *,char *,char *,int *);
int showmap(struct module_t *,char *,char *);

//from turrets.c
void mybox(struct module_t *,int ,int );
void mycircle(struct module_t *,int ,int , int ,int ,int );
void beamturret(struct module_t *,int ,int ,int ,int );
void rocketturret(struct module_t *,int ,int ,int ,int );
void myrocket(struct module_t *,int ,int ,int );
void slowturret(struct module_t *,int ,int ,int ,int );

void loadlevel(char *,char *,char *);
int lister(struct module_t *,struct menulist *,int );
void findit(char *,struct menulist *,int *);

struct cell{
	char l;
	short tid; 	//turret id
};

//properties for the snake target
struct nme{
	char a;   		// active
	int x;
	int y;
	char sx; 		// starting pos
	char sy;
	char sxd;		// starting directions
	char syd;
	//char t;   	// this is what path the object follows
	char sprite;
	char xd;
	char yd;
	int power;
	int speed;
	int ox;  		// offset to have smoother motion
	int oy;
	int value;
	char pause; 	// if this is >0 then stop
};

// properties for each turret
struct atr{
	char a;       	// active
	char tp;		// type 1=beam 2=rocket 3=slow (matches weapon id)
	char x;
	char y;
	int power;
	int multi;   	// this is what the power is multiplied by
	int r;     		// range
	int rmulti;   	// this is what the range is multiplied by
	int charge;		// if this >0 then don't fire
	short t;      	// target
	char ra[5];		// rockets active
	short rx[5];	// rocket x
	short ry[5];   	// rocket y
};



// cost,name,range,charge time,power
struct mywep weapon[]={
{100,"Single Beam","Lower power beam weapon",3,0,1},
{300,"Rocket Launcher","Fires seeking rockets",6,10,10},
{100,"Slow Beam","Stuns targets",3,10,0},
{250,"Double Beam","Slightly better basic weapon",4,0,3},
{900,"Heavy Launcher","More powerful launcher",6,10,100},
{500,"Slow Beam II","Stun and damages targets",3,5,10},
{500,"Pulse Cannon","Charge beam weapon",5,20,100},
{1000,"Force Beam","Powerful beam weapon",5,0,50}
};

// name,sprite,hp,speed,value
struct mynme nmelevel[]=
{
{"Squares",0,10,2,10},
{"Triangle",1,20,2,15},
{"Diamonds",2,50,2,30},
{"Stars",3,80,2,40},
{"Squares",0,120,2,50},
{"Triangle",1,170,2,60},
{"Diamonds",2,230,2,70},
{"Stars",3,350,2,80},
};

struct atr turret[20];
struct nme p[20];
struct cell grid[20][20];
struct listinfo mylist[20];

char map0[]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
's',1,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,
's',1,1,1,1,1,1,1,2,1,0,0,6,1,1,1,1,2,0,0,
0,0,0,0,0,0,0,0,1,1,0,0,1,6,1,1,2,1,0,0,
'e',1,4,0,0,0,0,0,1,6,1,1,8,1,0,0,1,1,0,0,
'e',4,1,0,0,0,0,0,6,1,1,1,1,8,0,0,1,1,0,0,
0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,1,1,0,0,0,0,0,0,0,0,2,1,1,1,1,4,1,0,0,
0,1,8,1,1,1,4,0,0,0,0,1,2,1,1,1,1,4,0,0,
0,8,1,1,1,4,8,1,1,1,1,4,1,0,0,0,0,0,0,0,
0,0,0,0,0,8,1,1,1,1,1,1,4,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

char map1[]={
0,0,0,0,0,0,0,0,0,'s','e',0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
'e',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,'s',
's',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,'e',
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,'e','s',0,0,0,0,0,0,0,0,0,
};

//    8
//  4   6
//    2

char map2[]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,6,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,0,
0,1,6,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,0,
0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,
0,1,1,0,'e','e',0,0,0,0,0,0,0,0,0,0,0,1,1,0,
0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,
0,1,1,0,1,8,1,1,1,1,1,1,1,1,1,1,1,4,1,0,
0,1,1,0,8,1,1,1,1,1,1,1,1,1,1,1,1,1,4,0,
0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,1,8,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,'s',
0,8,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,'s',
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

char map3[]={
1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
's',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,0,0,
's',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'e','e',0,1,
};


char *mapnames[]={"Map Zero","Crossroads","Cybiko Swirl","Turn Right"};

//default scores are default starting money
int mapscores[]={CASH,CASH,CASH,CASH};

char numstr[10];
char mapname[15];

long main(int argc, char *argv[],bool start){
	char extmap; 	// Whether map is builtin or loaded
	char abort=0;
	char now;
	char mapno=-1;
	
	int hiscore;
	int dist,tdist;

	int pos=0;
	int i,j;
	int e;
	
	char pt,no,enemies,x1,y1;
	char c,t,ext;
	const char rocket=0;
	char level,enemycount,levenemies;
	char *dis,*data,*maps[4],nmestarts,scanned;
	data=(char *)malloc(MAPWIDTH*MAPHEIGHT); 

	init_module( &main_module );

	dis=DisplayGraphics_get_page_ptr(main_module.m_gfx, 0);

	Bitmap_ctor_Ex2( &bmp, 160, 100, 2 );
	Graphics_ctor( &vgfx );
	Graphics_set_bitmap( &vgfx, &bmp );

	ptr_direct_keyboard = DirectKeyboard_get_instance();

	listitem=(struct menulist *)calloc(30,sizeof(struct menulist));

	// TRACE(VERSION);
	// TRACE("CybikoTD "+VERSION+"by ssjx\nhttp://www.ssjx.co.uk");

//
// Main game loop
//
do{	
	
	TRACE("Starting Game..");
	// Clear buffer bitmap
	DisplayGraphics_fill_screen( &vgfx, CLR_WHITE);
	TGraph_set_color( &vgfx, CLR_DKGRAY );
	//
	// Introduction 
	//

	do{
		char option;
		mapno=-1;
		
		//clear visible screen
		memset( dis, 0, 4000); 
	
		for(j=0;j<MAPHEIGHT+1;j++){
			for(i=0;i<MAPWIDTH;i++){
				mycircle(&main_module,i,j,0,0,0);
			}
		}
		
		strcpy(mylist[0].text,"Tower Defence for Cybiko");
		strcpy(mylist[1].text,"by ssjx (09/2023)");
		strcpy(mylist[2].text,VERSION);
		strcpy(mylist[3].text,"");
		strcpy(mylist[4].text,"Start!");
		strcpy(mylist[5].text,"Load a map");
		strcpy(mylist[6].text,"Controls");
		strcpy(mylist[7].text,"Quit");
		strcpy(mylist[8].text,"");
	
		option=selectwindow(&main_module,&mylist,9);
		
		// Escape quit
		if (option==-1){
			option=3;
		}
		
		switch(option){
			case 0:
				// Start
				// Choose a map
				maps[0]=map0;
				maps[1]=map1;
				maps[2]=map2;
				maps[3]=map3;
				mapno=selectmap(&main_module,maps,mapnames,mapscores);
				if (mapno!=-1){
					extmap=0;
					memcpy(data,maps[mapno],MAPWIDTH*MAPHEIGHT);	
				}
			break;
			
			case 1:
				//Scanned for file, only do this once per game
				if (scanned==0){
					char maxf=0;
					strcpy(mylist[0].text,"Searching for maps...");
					smallwindow(&main_module,"",&mylist,1,0);
					
					findit("*.ctd",listitem,&maxf);
					findit("/A/*.ctd",listitem,&maxf);
					findit("/MP3/*.ctd",listitem,&maxf);
					scanned=1;
					
					if (maxf>0){
						//select and load a map
						int choice=lister(&main_module,listitem,maxf);
						if (choice!=-1){
							char myfile[50];
							strcpy(myfile,listitem[choice].name);
							loadlevel(data,myfile,mapname);
							mapno=choice;
							extmap=1;
						}
					}else{
						strcpy(mylist[0].text,"No maps found!");
						smallwindow(&main_module,"",&mylist,1,1);
					}
				}
			
			break;
			
			case 2:
				strcpy(mylist[0].text,"Controls");
				strcpy(mylist[1].text,"");
				strcpy(mylist[2].text,"Arrows/QAOP");
				strcpy(mylist[3].text,"Select : Change weapon");
				strcpy(mylist[4].text,"Tab/Ctrl : Weapon select");
				strcpy(mylist[5].text,"Enter : Place weapon");
				strcpy(mylist[6].text,"Space : Quit");
				strcpy(mylist[7].text,"");
				strcpy(mylist[8].text,"");
				infowindow(&main_module,"",&mylist,9);
			break;
			
			case 3:
				abort=1;
				mapno=999;
			break;
		}
	
	}while(mapno==-1);
	
	//
	// Start the game
	//
	
	if (abort==0){
		//
		char lives=16;
		char level=0;
		char turrets=0;
		char yp=5; 	//  player arrow start position
		char xp=8;
		int money=CASH;
		int wid=0;
			
		// reset turrets and snake
		memset( p, 0, sizeof(p));
		memset( turret, 0, sizeof(turret));	
		TRACE("Turret size:%d bytes",sizeof(turret));
		
		//
		strcpy(mylist[0].text,"Level 1");
		strcpy(mylist[1].text,"Get Ready!");
		smallwindow(&main_module,"",&mylist,2,1);
			
		// DON'T CLEAR MAP! LEVELS ARE PLAYED ON SAME MAP!

		// Set the map data
		nmestarts=0;
		pos=0;
		for(j=0;j<MAPHEIGHT;j++){
			for(i=0;i<MAPWIDTH;i++){
				// Enemy start positions
				grid[i][j].l=data[pos++];
				if (data[pos]=='s'){nmestarts++;}
				
				// By drawing the map on a hidden bitmap, we can quickly copy it to the screen
				// to save redrawing the same things again and again.
				if (grid[i][j].l==0){
					DisplayGraphics_draw_rect (&vgfx, (i<<3), (j<<3),8,8); 	
				}
				
			}
		}
		TRACE("Enemy start positions: %d",nmestarts);
		
		do{
			// Clear screen
			memset( dis, 0, 4000);
			
			ext=0;
			TRACE("Level %d",level);
						
			// Set enemy start positions
			enemies=0;
			for(c=0;c<4;c++){
				pos=0;
				for(j=0;j<MAPHEIGHT;j++){
					for(i=0;i<MAPWIDTH;i++){
						if (data[pos]=='s'){
							p[enemies].x=i;
							p[enemies].y=j;							
							enemies++;
						}
						pos++;
					}
				}
			}
			
			TRACE("%d enemies!",enemies);
			
			// levenemies 	= this is the max nmes on a level (does not change)
			// enemycount 	= active on the map
			levenemies=enemies;
			enemycount=enemies;
			
			//
			for(i=0;i<enemies;i++){	
				//clear directions
				p[i].xd=0;
				p[i].yd=0;
				// set the correct start direction
				if (p[i].x==0 ){p[i].xd=1;}
				if (p[i].x==19 ){p[i].xd=-1;}
				if (p[i].y==0 ){p[i].yd=1;}
				if (p[i].y==11 ){p[i].yd=-1;}
				
				// active enemy
				p[i].a=1;
				p[i].ox=0;
				p[i].oy=0;	
				p[i].power=nmelevel[level].hp;
				p[i].value=nmelevel[level].value;
				p[i].speed=nmelevel[level].speed;
				p[i].sprite=nmelevel[level].sprite;
				p[i].sx=p[i].x;
				p[i].sy=p[i].y;	
				p[i].sxd=p[i].xd;
				p[i].syd=p[i].yd;
				p[i].pause=0;	
			}
			
			// enemies = current number of enemies sent
			enemies=0;
			now=0;
			
			do{
				if (enemies<levenemies){
					now++;	// Delay counter
					if (now>8){
						enemies+=nmestarts;
						now=0;
					}
				}
			
				// Player Controls
				/*
				switch(getinput(&main_module))
				{
				case KEY_SPACE:
					ext=-1;
				break;
				}
				*/
			
				DirectKeyboard_scan( ptr_direct_keyboard );
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_SPACE ) ){ext=-1;}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_H ) ){
					snapshot(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0));
				}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_Q) ){yp--;}
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_UP) ){yp--;}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_A ) ){yp++;}
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_DOWN ) ){yp++;}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_O ) ){xp--;}
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_LEFT ) ){xp--;}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_P ) ){xp++;}
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_RIGHT ) ){xp++;}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_SELECT ) ){
					wid++;
					if (wid>7){wid=0;}
					TRACE("%d %s",wid,weapon[wid].name);
				}
			
			
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_ENTER ) ){
					if (grid[xp][yp].l==0) {	
						if ((money-weapon[wid].cost)>=0){
							turret[turrets].a=0;
							turret[turrets].x=xp;
							turret[turrets].y=yp;
							turret[turrets].multi=1;
								
							turret[turrets].tp=wid;
							turret[turrets].r=weapon[wid].range;
							turret[turrets].power=weapon[wid].power;
						
							TRACE("id %d /  charge time: %d",wid,weapon[turret[turrets].tp].charge);
						
							money-=weapon[wid].cost;
							grid[xp][yp].l=9;
							grid[xp][yp].tid=turrets;
							
							turrets++;			
						}else{
							TRACE("You can't afford that!");
						}
						TRACE("Funds : %d",money);
					}
				}
			
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_TAB ) ){
					wid=selectweapon(&main_module,weapon,money);
				}
				
				if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_CONTROL ) ){
					wid=selectweapon(&main_module,weapon,money);
				}
				
				if (xp<0){xp=0;}
				if (xp>19){xp=19;}
				if (yp<0){yp=0;}
				if (yp>11){yp=11;}
				
				memset( dis, 0, 4000);
				// Draw map
				
				//TRACE("Drawing map...");
			
				Graphics_draw_bitmap( main_module.m_gfx, &bmp, 0,0, BM_NORMAL );
					
				for(j=0;j<MAPHEIGHT;j++){
					for(i=0;i<MAPWIDTH;i++){
					
						if (grid[i][j].l==9){
							t=grid[i][j].tid;
								
							switch (turret[t].tp)
							{
							case 0:
								beamturret(&main_module,i,j,turret[t].r,0);
							break;
				
							case 1:
								rocketturret(&main_module,i,j,turret[t].r,0);
							break;
				
							case 2:
								slowturret(&main_module,i,j,turret[t].r,0);
							break;
				
							case 3:
								beamturret(&main_module,i,j,turret[t].r,1);
							break;
							
							case 4:
								rocketturret(&main_module,i,j,turret[t].r,1);
							break;
				
							case 5:
								slowturret(&main_module,i,j,turret[t].r,1);
							break;
							
							case 6:
								beamturret(&main_module,i,j,turret[t].r,2);
							break;
							
							case 7:
								beamturret(&main_module,i,j,turret[t].r,3);
							break;
							}
						}
					}
				}
		
				//
				// change trail dir
				//
				
				//TRACE("Trail pos...");
				
				for(no=0;no<enemies;no++){
					if (p[no].a==1){
						char xdir=p[no].xd;
						char ydir=p[no].yd;
								
						if (p[no].ox==0 && p[no].oy==0){
							char px=p[no].x;
							char py=p[no].y;
						
							if (grid[px][py].l=='e'){
								// Reached exit
								lives--;
								TRACE("Lives: %d",lives);
								p[no].x=p[no].sx;
								p[no].y=p[no].sy;				
								p[no].xd=p[no].sxd;
								p[no].yd=p[no].syd;
								xdir=p[no].sxd;
								ydir=p[no].syd;
								// TRACE("x:%d y:%d ox:%d oy:%d",p[no].x,p[no].y,p[no].ox,p[no].oy);	
							}else{
								// If we've hit a marker then turn
								if (grid[px][py].l==8){ydir=-1;xdir=0;}
								if (grid[px][py].l==4){xdir=-1;ydir=0;}
								if (grid[px][py].l==6){xdir=1;ydir=0;}
								if (grid[px][py].l==2){ydir=1;xdir=0;}
								p[no].xd=xdir;
								p[no].yd=ydir;
							}
						}
					
						mycircle(&main_module,p[no].x,p[no].y,p[no].ox,p[no].oy,p[no].sprite);
						
						if (p[no].pause==0){
							p[no].ox+=(xdir*p[no].speed);
							p[no].oy+=(ydir*p[no].speed);
							//shift left 3 = *8
							if (p[no].ox==(xdir<<3)){p[no].ox=0; p[no].x+=xdir;}
							if (p[no].oy==(ydir<<3)){p[no].oy=0; p[no].y+=ydir;}
						}else{
							p[no].pause-=1;
						}
					}
				}
				
				//
				// Check if turret targets are still in range
				// set turret to inactive if not
				//
				// Check here so turret stays on single target for
				// as long as in range
				//
				
				for(t=0;t<turrets;t++){
					if (turret[t].a==1){
						e=turret[t].t;
						
						//don't target non active things
						if (p[e].a==0){
							turret[t].a=0;
						}else{
							x1=abs(turret[t].x-p[e].x);
							y1=abs(turret[t].y-p[e].y);
							x1=x1*x1;
							y1=y1*y1;
							
							dist=x1+y1;
							// Disengage if out of range
							if ((turret[t].r*turret[t].r)<dist) { turret[t].a=0;}
						}	
					}
					if (turret[t].charge>0) {turret[t].charge--;}
				}
				
				//
				// See if a target is in range of an inactive turret
				//
				
				//TRACE("Turret range check...");
				
				//tdist=1000;
				for(t=0;t<turrets;t++){
					// Only target if: inactive, charged, no active rockets
					if (turret[t].a==0 && turret[t].charge==0 && turret[t].ra[0]==0){
					
						for(e=0;e<enemies;e++){
							if (p[e].a==1){
								x1=abs(turret[t].x-p[e].x);
								y1=abs(turret[t].y-p[e].y);
								x1=x1*x1;
								y1=y1*y1;
								
								dist=x1+y1;
								
								// Really should target the closest...
								
								if (dist<(turret[t].r*turret[t].r)){
									turret[t].a=1;
									turret[t].t=e;
									// Shift left 3 = *8
									
									// Rocket Turret Normal / Heavy
									if (turret[t].tp==1 || turret[t].tp==4){
										turret[t].ra[0]=(turret[t].r<<3); // Used as range by rockets
										turret[t].rx[0]=(turret[t].x<<3)+4;
										turret[t].ry[0]=(turret[t].y<<3)+4;
									}	
								}
							}
						}
					}
				}
				
			//
			// Draw turret to target beam and remove target if necessary
			//
			//TRACE("Turret fire...");
			
			for(t=0;t<turrets;t++){
				if (turret[t].a==1){
					e=turret[t].t; // id of target
			
					switch (turret[t].tp)
					{
				
					case 3:
					case 7:
						// double beam
						TGraph_draw_line(main_module.m_gfx,2+(turret[t].x<<3),4+(turret[t].y<<3),(4+p[e].ox)+(p[e].x<<3),(4+p[e].oy)+(p[e].y<<3) );	
					case 0:
					case 6:
						// beam turret
						TGraph_draw_line(main_module.m_gfx,4+(turret[t].x<<3),4+(turret[t].y<<3),(4+p[e].ox)+(p[e].x<<3),(4+p[e].oy)+(p[e].y<<3) );
						p[e].power-=(turret[t].power*turret[t].multi);
					break;
						
					case 4:	
					case 1:
						// Rockets updated below!
					
					break;
					
					case 5:
						//slow turret2 (two beams)
						TGraph_draw_line(main_module.m_gfx,2+(turret[t].x<<3),4+(turret[t].y<<3),(4+p[e].ox)+(p[e].x<<3),(4+p[e].oy)+(p[e].y<<3) );	
				
					case 2:
						//slow turret		
						TGraph_draw_line(main_module.m_gfx,4+(turret[t].x<<3),4+(turret[t].y<<3),(4+p[e].ox)+(p[e].x<<3),(4+p[e].oy)+(p[e].y<<3) );				
						p[e].pause=10;
					break;
					}
				
					//check to see if enemy is still active first
					//in case destroyed by another tower
					if (p[e].power<=0 && p[e].a==1){
						p[e].a=0;
						p[e].power=0;
						enemycount--;
						money+=p[e].value;
						TRACE("Enemy destroyed! +%dc (%d remain)",p[e].value,enemycount);	  
					}
					
					//set weapon to recharge
					turret[t].charge=weapon[turret[t].tp].charge;
					if (turret[t].charge>0){turret[t].a=0;}
					
				//	TRACE("Turret charge: %d",weapon[turret[t].tp].charge);
				}
			}
			
			// As rockets may be active if turrets are not we check them
			// seperately
			//
			
			for(t=0;t<turrets;t++){
				e=turret[t].t; //id of target
			
				switch (turret[t].tp)
				{
				case 4:	
				case 1:
					// Rocket turret
					if (p[e].a==0){turret[t].ra[rocket]=0;} //deactivate rocket if target inactive
					
					if (turret[t].ra[rocket]>0){
						// Enemy position
						i=(4+p[e].ox)+(p[e].x<<3);
						j=(4+p[e].oy)+(p[e].y<<3);
						
						if (turret[t].rx[rocket]<i) { turret[t].rx[rocket]+=2;}
						if (turret[t].rx[rocket]>i) { turret[t].rx[rocket]-=2;}
						if (turret[t].ry[rocket]<j) { turret[t].ry[rocket]+=2;}
						if (turret[t].ry[rocket]>j) { turret[t].ry[rocket]-=2;}
								
						if (turret[t].tp==1){
							myrocket(&main_module, turret[t].rx[rocket],turret[t].ry[rocket],0);
						}else{
							myrocket(&main_module, turret[t].rx[rocket],turret[t].ry[rocket],1);
						}
				
						// See if rocket has hit the target
						if (turret[t].ry[rocket]==j){
							if (turret[t].rx[rocket]==i){
								p[e].power-=(turret[t].power*turret[t].multi);
								turret[t].ra[rocket]=0; //deactivate rocket	
								
								// check to see if enemy is still active first
								// in case destroyed by another tower
								if (p[e].power<=0 && p[e].a==1){
									p[e].a=0;
									p[e].power=0;
									enemycount--;
									money+=p[e].value;
									// TRACE("Enemy destroyed by rocket! +%dc (%d remain)",p[e].value,enemycount);	  
								}
							}
						}
						
						// Decrease fuel
						turret[t].ra[rocket]-=2;
						if (turret[t].ra[rocket]<0){turret[t].ra[rocket]=0;}
					}
				break;	
				default:
					//clear rockets range value of all other turrets
					turret[t].ra[rocket]=0;
				break;
				}
			}
			
			// On screen displays
			Graphics_set_font( main_module.m_gfx, mini_normal_font );
			sprintf(numstr,"%s (%dc/%dc)", weapon[wid].name, weapon[wid].cost,money);
			hitext(&main_module, numstr, 2, 2 );
			
			sprintf(numstr,"Level: %d Lives: %d", (level+1),lives);
			hitext(&main_module, numstr, 2, 90 );
			
			Graphics_set_font(main_module.m_gfx, mini_bold_font );
			
			// Draw player arrow on top
			arrow(&main_module,xp,yp);
			
			DisplayGraphics_show(main_module.m_gfx );
			
			// End of loop
			if (lives<=0){ext=1;}
			if (enemycount==0){
				ext=2;
				TRACE("Level %d completed! Funds: %d",level,money);
				level++;
				money+=((money*3)/100);
				TRACE("3% Interest added. Funds now: %d",money);
			}
			
			}while(ext==0);
			// off the level
			
			//
			if (ext==2){
				strcpy(mylist[0].text,"Level Completed!");
				strcpy(mylist[1].text,"3% int added to funds");
				sprintf(numstr,"Next Enemy Power:%d", nmelevel[level].hp);
				strcpy(mylist[2].text,numstr);
				strcpy(mylist[3].text,"Get Ready!");
				smallwindow(&main_module,"",&mylist,4,1);
			}
		
		}while(lives>0 && level<MAXLEVELS && ext!=-1);
		
			// Game Over
			// Lose
			if (lives==0){
				// TRACE("Bad luck, you lose..");
				strcpy(mylist[0].text,"Bad luck, you lose..");
				sprintf(numstr,"Score :%dc",money);
				strcpy(mylist[1].text,numstr);
				smallwindow(&main_module,"",&mylist,2,1);
			}
			
			// Complete
			if (level==MAXLEVELS){
				// TRACE("Well done! You completed all of the levels!");
				strcpy(mylist[0].text,"Well Done!");
				strcpy(mylist[1].text,"Levels Completed");
				sprintf(numstr,"Funds :%dc", money);
				strcpy(mylist[2].text,numstr);	
				smallwindow(&main_module,"",&mylist,3,1);
			}
			
				// Complete
			if (ext==-1){
				// TRACE("Player Quits!");
				strcpy(mylist[0].text,"Player Quits");
				strcpy(mylist[1].text,"");
				sprintf(numstr,"Funds :%dc", money);
				strcpy(mylist[2].text,numstr);	
				smallwindow(&main_module,"",&mylist,3,1);
			}
		
			// Only check for high score with built-in maps
			if (extmap==0){
				if (money>mapscores[mapno]){
				
				// TRACE("New High Score");
				strcpy(mylist[0].text,"New High Score!");
				
				sprintf(numstr,"New  :%dc", money);
				strcpy(mylist[1].text,numstr);
				
				sprintf(numstr,"Prev :%dc", mapscores[mapno]);
				strcpy(mylist[2].text,numstr);	
				
				mapscores[mapno]=money;
				
				smallwindow(&main_module,"",&mylist,3,1);
				}
			}
		}
	}while(abort==0);

	//
	// Outro
	//
	Graphics_set_font(main_module.m_gfx, mini_bold_font );

	strcpy(mylist[0].text,"Thanks for playing!");
	strcpy(mylist[1].text,"");
	strcpy(mylist[2].text,"Please visit:");
	strcpy(mylist[3].text,"");
	strcpy(mylist[4].text,"https://ssjx.co.uk");
	strcpy(mylist[5].text,"");
	strcpy(mylist[6].text,"For more Cybiko stuff!");
	
	infowindow(&main_module,"",&mylist,7);

	DirectKeyboard_dtor( ptr_direct_keyboard, FREE_MEMORY );
	
	free(data);
	free(listitem);

	Graphics_dtor( &vgfx,LEAVE_MEMORY  );

	Bitmap_dtor( &bmp, LEAVE_MEMORY );
	TRACE("Finished");

	return 0L;
}
