//
// Weapon/Map select
//
#include <cybiko.h>
#include "header.h"

// main
void mybox(struct module_t *,int ,int );
void beamturret(struct module_t *,int ,int ,int,int );
void rocketturret(struct module_t *,int ,int ,int,int );
void slowturret(struct module_t *,int ,int ,int,int );

// util
int waitinput(struct module_t *);

// gfx
void centext(struct module_t *,char *,int );
void simplemap(struct module_t *,char *,char *,int);

int selectweapon(struct module_t *ptr_main_module,struct mywep *tweapon,int money){
	int out=0,i,sel=0,ext=0;
	char num[50];

	do{
		DisplayGraphics_fill_screen(ptr_main_module->m_gfx, CLR_WHITE);
		
		TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
		TGraph_fill_rect(ptr_main_module->m_gfx,0,0,160,8);
		
		TGraph_draw_hline(ptr_main_module->m_gfx, 0, 73, 160 );
		TGraph_draw_hline(ptr_main_module->m_gfx, 0, 74, 160 );
		
		
		TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
		sprintf(num,"Funds: %dc",money);
		//	Graphics_set_font( ptr_main_module->m_gfx, mini_bold_font );
		DisplayGraphics_draw_text(ptr_main_module->m_gfx, num, 1, 0 );

		for(i=0;i<8;i++) {
			
			if (sel==i){
				TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
				TGraph_fill_rect(ptr_main_module->m_gfx,0,8+(i*8),160,8);
				
				TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text(ptr_main_module->m_gfx, tweapon[i].desc, 1, 75 );
					
				sprintf(num,"Cost: %dc",tweapon[i].cost);
				DisplayGraphics_draw_text(ptr_main_module->m_gfx, num, 1, 83 );
				
				sprintf(num,"Pwr: %d Chg:%d Rng:%d",tweapon[i].power,tweapon[i].charge,tweapon[i].range);
				DisplayGraphics_draw_text(ptr_main_module->m_gfx, num, 1, 91 );
			}
			
			if (tweapon[i].cost<=money){
				TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
			}else{
				if (sel==i){
					TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
				}else{
					TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
				}
			}
			
			DisplayGraphics_draw_text(ptr_main_module->m_gfx, tweapon[i].name, 24, 8+(i*8) );
				
			// turrets don't have the outline box so we have to add it here	
			TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
			TGraph_draw_rect( ptr_main_module->m_gfx, (1<<3),(1+i)<<3, 8, 8 );
				
				
			switch(i){
				case 0:
					beamturret(ptr_main_module,1 ,1+i ,0,0 );
				break;
				
				case 1:
					rocketturret(ptr_main_module,1 ,1+i ,0,0 );
				break;
				
				case 2:
					slowturret(ptr_main_module,1 ,1+i ,0,0 );
				break;
				
				case 3:
					beamturret(ptr_main_module,1 ,1+i ,0,1 );
				break;
				
				case 4:
					rocketturret(ptr_main_module,1 ,1+i ,0,1 );
				break;
				
				case 5:
					slowturret(ptr_main_module,1 ,1+i ,0,1 );
				break;
				
				case 6:
					beamturret(ptr_main_module,1 ,1+i ,0,2 );
				break;
				
				case 7:
					beamturret(ptr_main_module,1 ,1+i ,0,3 );
				break;			
			}
		}

		DisplayGraphics_show(ptr_main_module->m_gfx );

		switch( waitinput(ptr_main_module))
		   {
			case KEY_UP:
			case KEY_Q:
				sel--;
				if (sel<0){sel=7;}
			break; 

			case KEY_DOWN:
			case KEY_A:
				sel++;
				if(sel>7){sel=0;}
			break;
			
			case KEY_ENTER:
			case KEY_ESC:
				ext=1;
			break;
		}
	}while(ext==0);

	out=sel;
	//TRACE("ext:%d out:%d",ext,out);
	return out;
}

//
// Select a map
//
int selectmap(struct module_t *ptr_main_module,char *data[],char *name[],int hiscore[]){
	int sel=0,ext=0,out=-1;
	char *map;

	do{
		int score=hiscore[sel];
		map=data[sel];
		DisplayGraphics_fill_screen(ptr_main_module->m_gfx, CLR_WHITE);
	
		
		//display the map	
		simplemap(ptr_main_module,map,name[sel],score);	

		switch( waitinput(ptr_main_module))
		   {
			case KEY_RIGHT:
			case KEY_P:
				sel++;
				if(sel>3){sel=0;}
				
			break; 

			case KEY_LEFT:
			case KEY_O:
				sel--;
				if (sel<0){sel=3;}
			break;
			
			case KEY_ENTER:
			case KEY_SPACE:
				ext=1;
			break;	
			
			case KEY_ESC:
				ext=-1;
			break;
		}
	}while(ext==0);

	out=sel;
	if (ext==-1){out=-1;}
	return out;
}


// Just show a map and title. Used by level loader too..
void simplemap(struct module_t *ptr_main_module,char *data,char *name,int hiscore)
{
	int pos=0,i,j;
	char text[40];

	DisplayGraphics_fill_screen(ptr_main_module->m_gfx, CLR_WHITE);

	TGraph_set_color(ptr_main_module->m_gfx, CLR_DKGRAY );
	for(j=0;j<MAPHEIGHT;j++){
		for(i=0;i<MAPWIDTH;i++){
		    if (data[pos++]==0){	    
				TGraph_draw_rect( ptr_main_module->m_gfx, (i<<3),(j<<3), 8, 8 );		
		    }
		}
	}
	
	memset(text,0,sizeof(text));
	sprintf(text,"< %s >",name);
	
	centext(ptr_main_module,"Enter=Play / Esc=Back",  10);
	centext(ptr_main_module,text,  70);
	
	if (hiscore>0){
		sprintf(text,"Hi:%d",hiscore);	
		centext(ptr_main_module,text,  80);
	}
								
	DisplayGraphics_show(ptr_main_module->m_gfx );
}
