//
// Standard useful functions
//

#include <cybiko.h>
#include "header.h"

void snapshot(char *);
//
//
//

int getinput(struct module_t *ptr_main_module){
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0;

	ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
		
	if(ptr_message->msgid==MSG_KEYDOWN){
		ptr_key_param = Message_get_key_param( ptr_message );
		num=ptr_key_param->scancode;
	}    

	cWinApp_defproc( ptr_main_module->m_process, ptr_message );
	Message_delete(ptr_message);

	return num;
}

//
//
//


int waitinput(struct module_t *ptr_main_module){
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0,exit=0;

	// Clear the message buffer of key downs presses
	while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYDOWN, MSG_KEYDOWN )){
		Message_delete( ptr_message );
		//	TRACE("Deleting message1");
	}
		 
	// Wait for a keypress
	do{
		ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
			
		if(ptr_message->msgid==MSG_KEYDOWN){
		  ptr_key_param = Message_get_key_param( ptr_message );  
		  num=ptr_key_param->scancode;
		  exit=1;
		}    

		//cWinApp_defproc( ptr_main_module->m_process, ptr_message );
		Message_delete(ptr_message);
		ptr_message = NULL;

	}while(exit==0);

	if (num==KEY_H){
		snapshot(DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0));
	}

	while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYDOWN, MSG_KEYDOWN )){
		Message_delete( ptr_message );
		//	TRACE("Deleting message2");
	}

	return num;
}


//
// Centered Text
//

void center(struct module_t *ptr_main_module,char *text,int y){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}

	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}

//
//
//

void infowindow(struct module_t *ptr_main_module,char *title,struct listinfo *tlist,int items){
	char i;

	// Cool shadow
	TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx,14,14,140,80);

	// Draw on top
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	TGraph_fill_rect(ptr_main_module->m_gfx,10,10,140,80);

	TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx,10+1,10+1,140-2,80-2);

	// Draw Title
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	//DisplayGraphics_draw_text(ptr_main_module->m_gfx, title, 15, 10 );
	//center(ptr_main_module, title,10 );

	// Draw text

	for(i=0;i<items;i++){
		center(ptr_main_module, tlist[i].text,12+(i*10) );
	}

	DisplayGraphics_show(ptr_main_module->m_gfx);

	// Wait to exit
	waitinput(ptr_main_module);
}

int selectwindow(struct module_t *ptr_main_module,struct listinfo *tlist,int items){
	const int width=150;
	const int height=90;
	char out=0;
	char temp[30];

	// Cool shadow
	TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx,((160-width)>>1)+2,((100-height)>>1)+2,width,height);

	// Draw on top
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	TGraph_fill_rect(ptr_main_module->m_gfx,(160-width)>>1,(100-height)>>1,width,height);

	// Wait to exit
	for(;;){
		int key;
		int i;
		TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
		//TGraph_fill_rect(ptr_main_module->m_gfx,10+1,10+1,width-2,height-2);

		TGraph_fill_rect(ptr_main_module->m_gfx,((160-width)>>1)+1,((100-height)>>1)+1,width-2,height-2);

		// Draw text
		TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );

		for(i=0;i<items;i++){
			if (i==(4+out)){
				sprintf(temp,"*%s*",tlist[i].text);
				center(ptr_main_module, temp,7+(i*10) );
			}else{
				center(ptr_main_module, tlist[i].text,7+(i*10) );
			}
		}

		DisplayGraphics_show(ptr_main_module->m_gfx);

		key=waitinput(ptr_main_module);

		if (key==KEY_UP||key==KEY_Q){out--;}
		if (key==KEY_DOWN||key==KEY_A){out++;}

		if (out<0){out=3;}
		if (out>3){out=0;}


		if (key==KEY_ENTER || key==KEY_SPACE){break;}
		if (key==KEY_ESC){
			out=-1;
			// TRACE("Escape %d",out);
			break;
		}
	}
	#if DEBUG==1
		TRACE("Out %d",out);
	#endif
	return out;
}

//
// Snapshot - Takes a screen grab and saves it as snapshot.pic
//

void snapshot(char *in){
	struct FileOutput file_output;
	const long hd1=0x0201a064;
	const long hd2=0x0000a064;

	char fn[30],i=0,exists=0;
	FileOutput_ctor( &file_output );

	do{
		exists=0;
		memset(fn,0,sizeof(fn));
		sprintf(fn,"tower%d.pic",i);
		if( File_exists( fn )) {exists=1;i++;}
	}while(exists==1);

	if( FileOutput_open( &file_output, fn, TRUE ) ){
		FileOutput_write( &file_output,&hd1,4);
		FileOutput_write( &file_output,&hd2,4);
		FileOutput_write( &file_output,in,4000);
	}

	FileOutput_dtor( &file_output, LEAVE_MEMORY );
	TRACE("Snapshot Taken, saved as %s",fn);
}


// Return absolute value
int abs(int num){
	int out=(num<0)?(-num):(num);
	
	//if (num<0){out=-num;}else{out=num;}
	return out;
}



void smallwindow(struct module_t *ptr_main_module,char *title,struct listinfo *tlist,int items,int wt){
	char i;

	int height=(items*11);
	int starty=(100-height)>>1;

	// Cool shadow
	TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx,14,starty+4,140,height);

	// Draw on top
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	TGraph_fill_rect(ptr_main_module->m_gfx,10,starty,140,height);

	TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx,10+1,starty+1,140-2,height-2);

	// Draw Title
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	//DisplayGraphics_draw_text(ptr_main_module->m_gfx, title, 15, 10 );
	//center(ptr_main_module, title,10 );

	// Draw text

	for(i=0;i<items;i++){
		center(ptr_main_module, tlist[i].text,starty+1+(i*10) );
	}

	DisplayGraphics_show(ptr_main_module->m_gfx);

	// Wait to exit
	if (wt==1){
		waitinput(ptr_main_module);
	}
}

